# -*- coding: utf-8 -*-
import xbmc, xbmcgui, xbmcplugin, xbmcaddon, os, urllib, sys, urllib2, time
PLUGIN_NAME   = 'plugin.video.pazl3.tv'
addon = xbmcaddon.Addon(id='plugin.video.pazl3.tv')
__settings__ = xbmcaddon.Addon(id='plugin.video.pazl3.tv')
try: arhive = xbmcaddon.Addon(id='plugin.video.pazl.arhive')
except: pass

Pdir = addon.getAddonInfo('path')
icon = xbmc.translatePath(os.path.join(addon.getAddonInfo('path'), 'icon.png'))
fanart = xbmc.translatePath(os.path.join(addon.getAddonInfo('path'), 'fanart.png'))
Logo = xbmc.translatePath(os.path.join(addon.getAddonInfo('path'), 'logo'))
UserDir = xbmc.translatePath(os.path.join(xbmc.translatePath("special://masterprofile/"),"addon_data","plugin.video.pazl3.tv"))

Lserv=[]
UrlCashe={}
BanCashe=[]
Lthread=[]


def ru(x):return unicode(x,'utf8', 'ignore')
def xt(x):return xbmc.translatePath(x)

def CRC32(buf):
		import binascii
		buf = (binascii.crc32(buf) & 0xFFFFFFFF)
		return str("%08X" % buf)

def showMessage(heading, message, times = 3000):
	xbmc.executebuiltin('XBMC.Notification("%s", "%s", %s, "%s")'%(heading, message, times, icon))

def fs_enc(path):
    sys_enc = sys.getfilesystemencoding() if sys.getfilesystemencoding() else 'utf-8'
    return path.decode('utf-8').encode(sys_enc)

def fs_dec(path):
    sys_enc = sys.getfilesystemencoding() if sys.getfilesystemencoding() else 'utf-8'
    return path.decode(sys_enc).encode('utf-8')


def lower(t):
	RUS={"А":"а", "Б":"б", "В":"в", "Г":"г", "Д":"д", "Е":"е", "Ё":"ё", "Ж":"ж", "З":"з", "И":"и", "Й":"й", "К":"к", "Л":"л", "М":"м", "Н":"н", "О":"о", "П":"п", "Р":"р", "С":"с", "Т":"т", "У":"у", "Ф":"ф", "Х":"х", "Ц":"ц", "Ч":"ч", "Ш":"ш", "Щ":"щ", "Ъ":"ъ", "Ы":"ы", "Ь":"ь", "Э":"э", "Ю":"ю", "Я":"я"}
	for i in range (65,91):
		t=t.replace(chr(i),chr(i+32))
	for i in RUS.keys():
		t=t.replace(i,RUS[i])
	t=t.lower()
	return t


def upper(t):
	RUS={"А":"а", "Б":"б", "В":"в", "Г":"г", "Д":"д", "Е":"е", "Ё":"ё", "Ж":"ж", "З":"з", "И":"и", "Й":"й", "К":"к", "Л":"л", "М":"м", "Н":"н", "О":"о", "П":"п", "Р":"р", "С":"с", "Т":"т", "У":"у", "Ф":"ф", "Х":"х", "Ц":"ц", "Ч":"ч", "Ш":"ш", "Щ":"щ", "Ъ":"ъ", "Ы":"ы", "Ь":"ь", "Э":"э", "Ю":"ю", "Я":"я"}
	for i in RUS.keys():
		t=t.replace(RUS[i],i)
	for i in range (65,90):
		t=t.replace(chr(i+32),chr(i))
	return t

if __settings__.getSetting("ACE_API")=='true': 
	import socket, threading, re

	class _TSServ(threading.Thread):
		def __init__(self, socket):
			self.pkey = 'n51LvQoTlJzNGaFxseRK-uvnvX-sD4Vm5Axwmc4UcoD-jruxmKsuJaH0eVgE'
			threading.Thread.__init__(self)
			self._sock = socket
			self._buffer = 65 * 1024
			self._last_received = ''
			self.active = True
			self.err = False
			self.auth_ok = False
			self.version = None
			self.files = None
			self.key = None
			self.index = None
			self.content_url = None
			self.can_save = False
			self.save_info = None
			self.state = 0
			self.status = [0, '', '']
			self.pause = False
			self.vod = True

		def push(self, command):
			print ('TSSERV: [%s]' % command)
			try:
				self._sock.send(command + '\r\n')
			except:
				self.err = True

		def run(self):
			while self.active and not self.err:
				try:
					self.temp = self._sock.recv(self._buffer)
				except:
					self.temp = ''
				self._last_received += self.temp
				ind = self._last_received.find('\r\n')
				if ind != -1:
					fcom = self._last_received
					while ind != -1:
						self._last_received = fcom[:ind]
						self.exec_com()
						fcom = fcom[(ind + 2):]
						ind = fcom.find('\r\n')
					self._last_received = ''

		def exec_com(self):
			line = self._last_received
			cmd = self._last_received.split(' ')[0]
			params = self._last_received.split(' ')[1::]
			if cmd != 'STATUS':
				print('TSSERV: {%s}' % self._last_received)
			if cmd == 'HELLOTS':
				try:
					self.version = params[0].split('=')[1]
				except:
					self.version = '1.0.6'
				try:
					if params[2].split('=')[0] == 'key':
						self.key = params[2].split('=')[1]
				except: 
					try:
						self.key = params[1].split('=')[1]
					except:
						print('TSSERV: no HELLO key received')
			elif cmd == 'AUTH':
				self.auth_ok = True
			elif cmd == 'LOADRESP':
				self.files = line[line.find('{'):len(line)]
			elif cmd == 'EVENT':
				if params[0] == 'cansave':
					if int(self.index) == int(params[1].split('=')[1]):
						self.can_save = True
						self.save_info = [params[1], params[2]]
				elif params[0] == 'getuserdata':
					self.push('USERDATA [{"gender": 1}, {"age": 3}]')
					self.err = True
			elif cmd == 'START':
				try:
					self.content_url = urllib2.unquote(params[0].split('=')[1])
				except:
					self.content_url = params[0]
			elif cmd == 'RESUME':
				self.pause = False
			elif cmd == 'PAUSE':
				self.pause = True
			elif cmd == 'SHUTDOWN':
				self.active = False
			elif cmd == 'STATE':
				self.state = int(params[0])
				if self.state == 6:
					self.err = True
			elif cmd == 'STATUS':
				self._get_status(params[0])

		def _get_status(self, params):
			ss = re.compile(r'main:[a-z]+', re.S)
			s1 = re.findall(ss, params)[0]
			st = s1.split(':')[1]

		def end(self):
			self.active = False

	try:
		import _winreg
		try:
			t = _winreg.OpenKey(_winreg.HKEY_CURRENT_USER, r'Software\AceStream')
		except:
			t = _winreg.OpenKey(_winreg.HKEY_CURRENT_USER, r'Software\TorrentStream')
		port_file = os.path.join(os.path.dirname(_winreg.QueryValueEx(t, 'EnginePath')[0]), r'acestream.port')
		gf = open(port_file, 'r')
		tsport=int(gf.read())
	except:
			#return "X PORT"
			tsport=62062

	sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
	sock.connect(('127.0.0.1', tsport))
	#sock.settimeout(3)
	tsserv = _TSServ(sock)




class window(xbmcgui.Action):
	def __init__(self):
		print '===================================================================================== window ============================================'
	def onAction(self, action):
		print '===================================================================================== action ============================================'
		print action.getId()

win = window()

class pPlayer(xbmc.Player):
	def __init__(self):
		print '===================================================================================== init ============================================'
		pass
	
	def onPlayBackStarted(self):
		last_id =__settings__.getSetting("cplayed")
		if last_id!='arh':
			print '===================================================================================== PlayBackStarted ============================================'
			if __settings__.getSetting("xplay")=='true' and xbmcgui.getCurrentWindowId() == 12005 and last_id!='arh': xbmc.executebuiltin("Action(Back)")
			xbmc.sleep(300)
			if __settings__.getSetting("xplay")=='true' and xbmcgui.getCurrentWindowId() == 12005 and last_id!='arh': xbmc.executebuiltin("Action(Back)")
			xbmc.sleep(300)
			xbmc.sleep(300)
			#time.sleep(1)
			try: PlayingFile = self.getPlayingFile()
			except: PlayingFile = ''
			print PlayingFile
			pt=0
			n=0
			ct=time.time()
			print '===================================================================================== PlayBack ============================================'
			while xbmc.Player().isPlaying():
						
					#print xbmcgui.getCurrentWindowId()
					if __settings__.getSetting("xplay")=='true' and xbmcgui.getCurrentWindowId() == 12005 and last_id!='arh': xbmc.executebuiltin("Action(Back)")
					xbmc.sleep(1000)
					try:
						#print self.getTime()
						if pt==self.getTime():
							n+=1
							print n
							if n == 1:
								if __settings__.getSetting("antifreeze")=='true': Player.pause()
								pass
								
							if n > 1:
								pass
								if __settings__.getSetting("autonext")=='0':
									print 'next strim'
									Player.play(playlist, windowed=True, startpos=playlist.getposition()+1)
									n=0
								if __settings__.getSetting("autonext")=='1':
									print 'restart strim'
									Player.play(playlist, windowed=True, startpos=playlist.getposition())
									n=0
								#xbmc.sleep(3000)
								#Player.pause()
						else:
							n=0
						pt=self.getTime()
					except: 
						print 'err auto'
						pass
			print '===================================================================================== PlayBack STOP ============================================'
			print xbmcgui.getCurrentWindowId()
		else:
			xbmc.executebuiltin("Action(FullScreen)")
		
	def onPlayBackPaused(self):
		print '===================================================================================== PlayBack Paused ============================================'
		#Player.play(playlist, windowed=True)
		#xbmc.sleep(2000)
		#self.seekTime(self.getTime()-1)
		#Player.pause()
		
	def onPlayBackEnded(self):
		print '===================================================================================== onPlayBackEnded ============================================'
		print xbmcgui.getCurrentWindowId()


class p2Player(xbmc.Player):
	def __init__(self):
		print '===================================================================================== 2init ============================================'
		pass
	
	def onPlayBackStarted(self):
		print '================================================================================= p2Player play =========================================='
	
	def onPlayBackSeek(self, time, seekOffset):
		print '================================================================================= p2Player Seek =========================================='

def getURL2(url):
	try:
		import requests
		try:
			s = requests.session()
			r=s.get(url, timeout=(0.1, 5), verify=False).text#0.00001
		except:
			print 'requests: timeout'
			r=''
		#r=r.encode('windows-1251')
		return r
	except:
		return ''

def getURL3(url,Referer = 'http://emulations.ru/'):
	req = urllib2.Request(url)
	req.add_header('User-Agent', 'Opera/10.60 (X11; openSUSE 11.3/Linux i686; U; ru) Presto/2.6.30 Version/10.60')
	req.add_header('Accept', 'text/html, application/xml, application/xhtml+xml, */*')
	req.add_header('Accept-Language', 'ru,en;q=0.9')
	req.add_header('Referer', Referer)
	response = urllib2.urlopen(req)
	link=response.read()
	response.close()
	return link

def getURL(url, Referer = 'http://viks.tv/'):
	return getURL2(url)
	req = urllib2.Request(url)
	req.add_header('User-Agent', 'Opera/10.60 (X11; openSUSE 11.3/Linux i686; U; ru) Presto/2.6.30 Version/10.60')
	req.add_header('Accept', 'text/html, application/xml, application/xhtml+xml, */*')
	req.add_header('Accept-Language', 'ru,en;q=0.9')
	req.add_header('Referer', Referer)
	response = urllib2.urlopen(req)
	link=response.read()
	response.close()
	return link

def SEND(command):
		serv_adr=__settings__.getSetting("serv_adr")
		url='http://'+serv_adr+'/'+command
		r=getURL(url)
		return r


def testURL(url):
	if __settings__.getSetting("test")=='false': return 0
	try:
		if 'gavrilovka.iptvbot' in url: return 999
		if 'ace/getstream' in url: 
			if __settings__.getSetting("p2p_test")=='true': url=url.replace('ace/getstream', 'ace/manifest.m3u8')
			else: return 0
		if '/udp/' in url: return 0
		import requests
		from datetime import datetime
		s = requests.session()
		d = datetime.now()
		try:
			r=s.get(url, timeout=(1, 0.1))#0000
			print '=-=-= requests -=-=-=- '
			print r
			if r=='<Response [404]>': return 999
			else: return 1
		except requests.exceptions.ReadTimeout:
				return int(str(datetime.now() - d)[-6:-3])
		except requests.exceptions.ConnectTimeout:
				return 999
	except:
		return 2#999


def GETimg(target, nmi):
	#lfimg=os.listdir(Logo)
	if nmi =='':return target
	
	LogoDir=__settings__.getSetting("logodir")
	if LogoDir=="":LogoDir=Logo
	path1 = fs_enc(os.path.join(LogoDir,nmi+'.png'))
	path2 = fs_enc(os.path.join(Logo,nmi+'.png'))
	try:
		print path1
		if os.path.isfile(path1): return path1
		else:
			if __settings__.getSetting("dllogo")=='false': return target
			print 'Загрузка логотипа: '+ nmi
			#pDialog = xbmcgui.DialogProgressBG()
			#pDialog.create('Пазл ТВ', 'Загрузка логотипа: '+ nmi)
			req = urllib2.Request(url = target, data = None)
			req.add_header('User-Agent', 'Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 5.1; Trident/4.0; Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1) ; .NET CLR 1.1.4322; .NET CLR 2.0.50727; .NET CLR 3.0.4506.2152; .NET CLR 3.5.30729; .NET4.0C)')
			resp = urllib2.urlopen(req)
			fl = open(path2, "wb")
			fl.write(resp.read())
			fl.close()
			#pDialog.close()
			return path2
	except:
		print "err: "+target
		return target



def mfind(t,s,e):
	r=t[t.find(s)+len(s):]
	r2=r[:r.find(e)]
	return r2

def mfindal(http, ss, es):
	L=[]
	while http.find(es)>0:
		s=http.find(ss)
		e=http.find(es, s+len(ss))
		i=http[s:e]
		L.append(i)
		http=http[e+2:]
	return L

def debug(s):
	fl = open(ru(os.path.join( addon.getAddonInfo('path'),"test.txt")), "w")
	fl.write(s)
	fl.close()

def inputbox(t=''):
	skbd = xbmc.Keyboard(t, ' ')
	skbd.doModal()
	if skbd.isConfirmed():
		SearchStr = skbd.getText()
		return SearchStr
	else:
		return t

def next (dr='>'):
		ccn=__settings__.getSetting("cplayed")
		print '=NEXT='
		print ccn
		#SG=get_SG()
		if dr=='>':
			__settings__.setSetting("lastnx",">")
			id =__settings__.getSetting("next_itm")
		else: 
			id =__settings__.getSetting("prev_itm")
			__settings__.setSetting("lastnx","<")
		__settings__.setSetting("v_id", id)
		name  = ""#DBC[id]['title']
		play(id, name, ref=False)
		return id


def set_np ():
	
	L=root(__settings__.getSetting("Sel_gr"))
	CL=[]
	for i in L:
		CL.append(i['id'])
	id=__settings__.getSetting("cplayed")
	#CL=get_cut_gr()
	n=CL.index(id)
	nn=n+1
	np=n-1
	if nn>=len(CL):nn=0
	__settings__.setSetting("next_itm",CL[nn])
	__settings__.setSetting("prev_itm",CL[np])
	
	if __settings__.getSetting("preload")=='true':
		get_allurls(CL[nn])


def play_ace2(url):
	s=url.find('getstream?id=')
	if s<0: return ""
	PID=url[s+13:]
	print PID
	
	tsserv.start()
	tsserv.push('HELLOBG version=3')
	#command='HELLOBG version=3'
	#sock.send(command + '\r\n')
	n=0
	while not tsserv.version:
			print tsserv.version
			n+=1
			xbmc.sleep(200)
			if n>50: return "X HELLOBG"
	import hashlib
	sha1 = hashlib.sha1()
	pkey = tsserv.pkey
	sha1.update(tsserv.key + pkey)
	key = sha1.hexdigest()
	pk = pkey.split('-')[0]
	ready_key = 'READY key=%s-%s' % (pk, key)
	tsserv.push(ready_key)
	#sock.send(ready_key + '\r\n')

	n=0
	while not tsserv.auth_ok:
			n+=1
			xbmc.sleep(200)
			if n>50: return "X READY"
	#PID=url
	tsserv.push('START PID '+PID+' 0')
	while not tsserv.state == 2:
			n+=1
			xbmc.sleep(200)
			if n>50: return "X START"
	return tsserv.content_url

def ACE2_end():
	try:
		tsserv.push('SHUTDOWN')
		sock.shutdown(socket.SHUT_RDWR)
		sock.close()
	except:
		pass


playlist = xbmc.PlayList (xbmc.PLAYLIST_VIDEO)


def update_Lt(d):
	global Lthread
	if d == 'reset':	Lthread=[]
	else:				Lthread.append(d)

from threading import Thread
class MyThread(Thread):
	def __init__(self, param):
		Thread.__init__(self)
		self.param = param
	
	def run(self):
		update_Lt(get_stream(self.param))


def create_thread(param):
		my_thread = MyThread(param)
		my_thread.start()

def play(id, name='' ,cover='', ref=True):
	try:
		inf = eval(SEND('/channel/'+id+'/inf'))
		if name == '': name  = inf['title']
		if cover =='': cover = inf['picon']
	except:pass
	if __settings__.getSetting("xplay")=='true': return play_vfs(id, name ,cover, ref)
	
	print '=-=-=-=-=-=-=-=-=-=-=-PLAY=-=-=-=-=-=-=-=-=-=-=-=-=-'
	pDialog = xbmcgui.DialogProgressBG()
	try:pDialog.create(name, 'Поиск потоков ...')
	except: pass
	
	try:
		print '=-=-=-=-=-=-=-=-=-=-=-PLAY get_all_channeles=-=-=-=-=-=-=-=-=-=-=-=-=-'
		
		Lpurl2=get_allurls(id)
		
		Player.stop()
		playlist.clear()
		Lpurl=[]
		Lsign=[]
		print '=-=-=-=-=-=-=-=-=-=-=-PLAY get_streams =-=-=-=-=-=-=-=-=-=-=-=-=-'
		fpl=0
		n=0
		
		if Lpurl2==[]:
			pDialog.close()
			#showMessage('Пазл ТВ', 'Канал недоступен')
			try:pDialog.create(name, '[COLOR FFFF5555]Канал недоступен[/COLOR]')
			except: pass

			#if __settings__.getSetting("xplay")=='true': Player.ov_hide()
			__settings__.setSetting("cplayed",id)
			try:n_play=int(__settings__.getSetting("n_play"))
			except:n_play=0
			if n_play<5:
				set_np ()
				__settings__.setSetting("n_play",str(n_play+1))
				pDialog.close()
				print 'NEXT '+__settings__.getSetting("lastnx")
				next (__settings__.getSetting("lastnx"))
			else:
				pDialog.close()
				return ""
			
		else:
			
			#playlist.clear()
			
			n=1
			#if len(Lpurl2)>1:n=3
			
			for j in range (0,n): # несколько копий в плейлист
				k=0
				for purl in Lpurl2:
					k+=1
					if ':6878' in purl: name2='[P2P]'
					else:
						name2='['+purl.replace('://',']')
						name2=name2[:name2.find('/')]
					item = xbmcgui.ListItem(name2+" [ "+str(k)+"/"+str(len(Lpurl2))+" ]", path=purl, thumbnailImage=cover, iconImage=cover)
					if __settings__.getSetting("restreamer") == 'true':
						import base64
						serv_adr=__settings__.getSetting("serv_adr")
						purl = 'http://'+serv_adr+'/restream/'+base64.b64encode(purl)
					playlist.add(url=purl, listitem=item)
			
			pDialog.close()
			#print Lpurl2
			__settings__.setSetting("cplayed",id)
			
			try: PlayingFile=Player.getPlayingFile()
			except: PlayingFile=''
			PlayingFile==''
			if __settings__.getSetting("fplay")=='false' or PlayingFile=='':
				if __settings__.getSetting("xplay")=='false':
					Player2.play(playlist)
				else:
					Player.play(playlist, windowed=True)
					#print xbmcgui.getCurrentWindowId()
			
			set_np ()
			#print xbmcgui.getCurrentWindowId()
			try: PlayingFile=Player.getPlayingFile()
			except: PlayingFile=''
			if PlayingFile=='':
				try:BanCashe.append(Lpurl2[0])
				except: pass
				
				try:n_play=int(__settings__.getSetting("n_play"))
				except:n_play=0
				if n_play<3:
					__settings__.setSetting("n_play",str(n_play+1))
					next (__settings__.getSetting("lastnx"))
			
			print '=-=-=-=-=-=-=-=-=-=-=-PLAY-end=-=-=-=-=-=-=-=-=-=-=-=-=-'
			#xbmcplugin.endOfDirectory(handle)
	except:
		try:pDialog.close()
		except: pass

def play_vfs(id, name='' ,cover='', ref=True):
	print '=-=-=-=-=-=-=-=-=-=-=-PLAY=-=-=-=-=-=-=-=-=-=-=-=-=-'
	if __settings__.getSetting("popup")=='true':
		pDialog = xbmcgui.DialogProgressBG()
		try:pDialog.create(name, 'Поиск потоков ...')
		except: pass
	try:
		Lpurl2=get_allurls(id)
		
		Player.stop()
		playlist.clear()
		if Lpurl2==[]:
			print '= Канал недоступен ='
			try: pDialog.close()
			except: pass
			if __settings__.getSetting("popup")=='true':
				try:pDialog.create(name, '[COLOR FFFF5555]Канал недоступен[/COLOR]')
				except: pass
			__settings__.setSetting("cplayed",id)
			set_np ()
			try: pDialog.close()
			except: pass
			return
		else:
			#playlist.clear()
			k=0
			for purl in Lpurl2:
					k+=1
					if ':6878' in purl: name2='[P2P]'
					elif '/udp/' in purl:
						if 'udp/224.3'     in purl: name2='[UDP] Vladnet'
						elif 'udp/238'     in purl: name2='[UDP] Tauer'
						elif 'udp/239.195.'in purl: name2='[UDP] Post'
						elif 'udp/232'     in purl: name2='[UDP] Aist'
						elif 'udp/233.33.2'in purl: name2='[UDP] Corbina'
						elif 'udp/239.192' in purl: name2='[UDP] Urgal'
						elif 'udp/224.0'   in purl: name2='[UDP] Digital'
						elif 'udp/239.2'   in purl: name2='[UDP] Elite'
						elif 'udp/234.0.0' in purl: name2='[UDP] Lada'
						elif 'udp/239.1.'  in purl: name2='[UDP] Novotel'
						elif 'udp/239.195' in purl: name2='[UDP] Optik'
						elif 'udp/239.191' in purl: name2='[UDP] Redkom'
						elif 'udp/225.50.' in purl: name2='[UDP] Lanta'
						else: name2='[UDP]???'
					else:
						name2='['+purl.replace('://',']')
						name2=name2[:name2.find('/')]
					item = xbmcgui.ListItem(name2+" [ "+str(k)+"/"+str(len(Lpurl2))+" ]", path=purl, thumbnailImage=cover, iconImage=cover)
					if __settings__.getSetting("restreamer") == 'true':
						import base64
						serv_adr=__settings__.getSetting("serv_adr")
						purl = 'http://'+serv_adr+'/restream/'+base64.b64encode(purl)
					playlist.add(url=purl, listitem=item)
			
			try: pDialog.close()
			except: pass
			
			__settings__.setSetting("cplayed",id)
			#xbmc.executebuiltin('RunScript("special://home/addons/plugin.video.pazl3.tv/closer.py")')
			#try: PlayingFile=Player.getPlayingFile()
			#except: PlayingFile=''
			
			#if  PlayingFile=='': 
			Player.play(playlist, windowed=True)
			
			set_np ()
	except:
			try: pDialog.close()
			except: pass
			__settings__.setSetting("cplayed",id)
			try:set_np ()
			except: pass

def select_stream():
	L=[]
	for i in range(0,playlist.size()):
		item=playlist.__getitem__(i)
		L.append(item.getfilename())
	
	sel = xbmcgui.Dialog()
	r = sel.select("Источники:", L)
	
	if r>=0:
		Player.play(playlist, windowed=True, startpos=r)


def play_archive(urls, name ,cover, ref=True):
	#print urls
	Player.stop()
	pDialog = xbmcgui.DialogProgressBG()
	try:pDialog.create('Пазл ТВ', 'Поиск потоков ...')
	except: pass
	Lpurl=[]
	for url in urls:
		#Lcurl=get_stream(url)
		try: Lcurl=get_archive(url)
		except:Lcurl=[]
		#print Lcurl
		try:Lpurl.extend(Lcurl)
		except:Lcurl=[]
	
	Lpurl2=[]
	Lm3u8 =[]
	Lrtmp =[]
	Lp2p  =[]
	Lourl =[]
	Ltmp=[]
	
	for i in Lpurl:
		if '.m3u8' in i and i not in Lm3u8:  Lm3u8.append(i)
		elif 'rtmp' in i and i not in Lrtmp: Lrtmp.append(i)
		elif '/ace/' in i and i not in Lp2p: Lp2p.append(i)
		elif i not in Ltmp:                  Lourl.append(i)
		Ltmp.extend(Lp2p)
		Ltmp.extend(Lm3u8)
		Ltmp.extend(Lrtmp)
		Ltmp.extend(Lourl)
	
	if __settings__.getSetting("ace_start")=='true' and len(Lp2p)>0: ASE_start()
	
	if __settings__.getSetting("p2p_start")=='true':
			Lpurl2.extend(Lp2p)
			Lpurl2.extend(Lm3u8)
			Lpurl2.extend(Lrtmp)
			Lpurl2.extend(Lourl)
	else:
			Lpurl2.extend(Lm3u8)
			Lpurl2.extend(Lourl)
			Lpurl2.extend(Lp2p)
			Lpurl2.extend(Lrtmp)
	
	if Lpurl2==['12321',]:
		pDialog.close()
		showMessage('Пазл ТВ', 'Канал недоступен')
		return ""
		
	else:
		playlist = xbmc.PlayList (xbmc.PLAYLIST_VIDEO)
		playlist.clear()
		
		n=1
		if len(Lpurl2)>1:n=3
		
		for j in range (0,n): # несколько копий в плейлист
			k=0
			for purl in Lpurl2:
				k+=1
				if __settings__.getSetting("split")=='true':name2=unmark(name)#.replace(" #1","")
				else:name2=colormark(name)#.replace(" #1","[COLOR 40FFFFFF] #1[/COLOR]")
				item = xbmcgui.ListItem(name2+" [ "+str(k)+"/"+str(len(Lpurl2))+" ]", path=purl, thumbnailImage=cover, iconImage=cover)
				playlist.add(url=purl, listitem=item)
		
		for j in range (0,5):
			purl2=os.path.join(addon.getAddonInfo('path'),"2.mp4")
			item = xbmcgui.ListItem(" > ", path=purl2, thumbnailImage=cover, iconImage=cover)
			playlist.add(url=purl2, listitem=item)
		
		
		pDialog.close()
		
		Player.play(playlist)
		xbmc.sleep(1000)
		#xbmcplugin.endOfDirectory(handle)



Lmrk=[]
for i in range (0,100):
		Lmrk.append(str(i))
Lmrk.reverse()

def unmark(nm):
	for i in Lmrk:
		nm=nm.replace(" #"+str(i),"")
	return nm

def uni_mark(nm):
	try:nm=lower(nm)
	except:pass
	return nm

def colormark(nm):
	for i in Lmrk:
		nm=nm.replace(" #"+str(i),"[COLOR 40FFFFFF] #"+str(i)+"[/COLOR]")
	return nm


def get_sign(st):
	n=st.replace('http://','')
	n=n[:n.find('.m3u')]
	return n


def appendgroup(group, id):
		if group !='':
			try:L=open_Groups()
			except:L=Ldf
			CL=[]
			for i in L:
				CL.append(i[0])
			
			if group in CL:
				add_to_gr(id, group)
			else:
				add_gr(group)
				add_to_gr(id, group)


def append_cnl(id):
	nm2id={}
	nml=[]
	L=eval(SEND('channels/dict'))
	for a in L:
		namet=a['title']
		idt=a['id']
		if id != idt:
			nm2id[namet]=idt
			nml.append(namet)
	nml.sort()
	sel = xbmcgui.Dialog()
	r = sel.select("Добавить к каналу:", nml)
	
	if r>=0:
		name=nml[r]
		print name
		id2=nm2id[name]
		print id2
		SEND('channel/'+id+'/unite/'+id2)


def split_cnl(id=''):
	if id!='':
		nm_list=eval(SEND('channel/'+id+'/inf'))['names']
		if len(nm_list)>1:
			sel = xbmcgui.Dialog()
			r = sel.select("Выделить как канал:", nm_list)
			if r>=0 :
				name=nm_list[r]
				SEND('channel/'+id+'/split/'+name)
		else:
			showMessage('Разделить нельзя', 'Канал содержит 1 имя')


def remove_cnl(id=''):
	if id!='': SEND('channel/'+id+'/rem')

def rename_cnl(id):
	nm=inputbox()
	if nm!='': SEND('channel/'+id+'/rename/'+nm)

def get_all_channeles():
	print '==get_all_channeles pass=='


def get_allurls(id):
	L=eval(SEND('streams/list/'+id))
	return L

def get_all_archive():
	pDialog = xbmcgui.DialogProgressBG()
	L=[]
	for i in Larh:
		serv_id=str(int(i[1:3]))
		if True:#__settings__.getSetting("serv"+serv_id+"")=='true' :
			
			try: exec ("import aid"+serv_id+"; Ds=aid"+serv_id+".n2id")
			except:Ds={}
			if Ds=={}: 
				pDialog.create('Пазл ТВ', 'Обновление архива #'+serv_id+' ...')
				Ds=upd_archive_db(i)
				pDialog.close()
		else: Ds={}
		if Ds !={}:
			Ds['srv_id']=i
			L.append(Ds)
	return L


def root(SG='all'):
	if SG=='':SG='all'
	L=eval(SEND('channels/dict/'+SG))
	if __settings__.getSetting("abc")=='true': L=sort_abc2(L)
	return L

def sort_abc2(L):
	L2=[]
	for i in L:
		try: L2.append((i['title'],i))
		except: pass
	L2.sort()
	L=[]
	for j in L2:
		L.append(j[1])
	return L


def sort_abc(L):
	L2=[]
	for id in L:
		try: L2.append((DBC[id]['title'],id))
		except: pass
	L2.sort()
	L=[]
	for i in L2:
		L.append(i[1])
	return L


def open_Groups():
		ls=eval(SEND('groups/dict'))
		return ls

def get_SG():
	try:SG=__settings__.getSetting("Sel_gr")
	except:SG=''
	if SG=='':
		SG='Все каналы'
		__settings__.setSetting("Sel_gr",SG)
	return SG

def get_gr(SG='', bl=True):
		CL=[]
		L=root(SG)
		for i in L:
			CL.append(i['id'])
		return CL


'''
def get_gr(SG='', blacklist=True):
	if SG=='':SG=get_SG()
	if SG=='Все каналы':
		CLf=DBC.keys()
	else:
		try:L=open_Groups()
		except:L=[]
		for i in L:
			if i[0]==SG: CLf=i[1]
	
	if blacklist: BL=get_blacklist_cn(SG)
	else: BL=[]
	if BL==[]: CL=CLf
	else:
		CL=[]
		for c in CLf:
			if c not in BL: CL.append(c)
	
	if __settings__.getSetting("abc")=='true' or SG=='Все каналы': CL=sort_abc(CL)
	return CL

def get_outbase():
	CL=DBC.keys()
	L=[]
	Lt=[]
	lid=[]
	for i in Lserv:
			serv_id=str(int(i[1:3]))
			try: Ls=get_cahe_list(serv_id)
			except:Ls=[]
			for c in Ls:
				name = c['title']
				#picon = c['img']
				try:group = c['group']
				except:group =''
				id = CRC32(uni_mark(name))
				if id not in CL:
					if id not in lid:
						lid.append(id)
						Lt.append(name)
						L.append({'title':name,'id':id,'group':group})#,'picon':picon
	
	sel = xbmcgui.Dialog()
	Lt.sort()
	#r = sel.multiselect("Добавить каналы:", Lt)
	r = sel.select("Добавить канал:", Lt)
	if r>0:
		st=Lt[r]
		for a in L:
			if a['title'] == st:
				DBC[a['id']]={'group': [a['group']], 'names': [uni_mark(a['title'])], 'title': a['title']}
				try: save_DBC(DBC)
				except: pass

				return True

	return False

def get_blacklist_cn(cgr=''):
		BL=[]
		try:L=open_Groups()
		except:L=[]
		for i in L:
			if len(i)==3 and i[0]!=cgr: BL.extend(i[1])
		return BL



def get_cut_gr():
		Lnm=[]
		Lserv=get_all_channeles()
		CL=get_gr()
		nml=[]
		for a in Lserv:
			nm=uni_mark(a['title'])
			nml.append(nm)
		for id in CL:
				try:
					names = DBC[id]['names']
					enable=False
					for b in names:
						if b in nml: enable=True
					
					if enable:
						#name  = DBC[id]['title']
						#cover = get_picon(id)
						if id not in Lnm:
							Lnm.append(id)
				except:
					pass
		return Lnm
'''
def get_autoexit_gr():
		SG=get_SG()
		try:L=open_Groups()
		except:L=[]
		for i in L:
			if len(i)==3:
				if i[2]!='false' and i[0]==SG: return True
		return False

def select_gr(ind, gui=False):
	L=open_Groups()
	Lg=['Все каналы',]
	for i in L:
		if len(i)==2:Lg.append(i[0])
		elif len(i)==3: 
			if i[2]=='false': Lg.append(i[0])
			else:             Lg.append('[COLOR 44FFFFFF]'+i[0]+'[/COLOR]')
	
	if gui: return Lg

def set_num_cn(id):
	try:SG=__settings__.getSetting("Sel_gr")
	except:SG=''
	if SG=='':SG='Все каналы'
	
	if SG!='Все каналы':
		CL=eval(SEND('group/'+SG+'/list'))
		#print CL
		CLn=[]
		for c in CL:
			if c['id']!=id: CLn.append(c['name'])
		CLn.append(' - В конец списка - ')
		sel = xbmcgui.Dialog()
		r = sel.select("Перед каналом:", CLn)
		if r>=0:
			SEND('group/'+SG+'/set_cn/'+id+'/num/'+str(r))


def add_to_gr(id, group=''):
	try:L=open_Groups()
	except:L=Ldf
	Lg=[]
	for i in L:
		Lg.append(i[0])
	if Lg!=[]:
		if group=='':
			sel = xbmcgui.Dialog()
			r = sel.select("Группа:", Lg)
		else:
			r=Lg.index(group)
		if r!=-1:
			SEND('channel/'+id+'/add_group/'+L[r][0])


def rem_from_gr(id):
	try:	SG=__settings__.getSetting("Sel_gr")
	except: SG=''
	if SG!='' and SG!='Все каналы': SEND('channel/'+id+'/rem_group/'+SG)


def update_cnl():
	pass

def add_gr(name=''):
	if name=='': name=inputbox()
	if name!='': SEND('/group/add/'+name)

def rem_gr(name=''):
	if name!='': SEND('/group/del/'+name)

def move_gr(name='', dir=''):
	if name!="":
		if dir=='':
			Lg=['/\ Выше', '\/ Ниже']
			sel = xbmcgui.Dialog()
			r = sel.select("Переместить группу:", Lg)
			if r==0: SEND('group/'+name+'/up')
			if r==1: SEND('group/'+name+'/down')
		else:
			SEND('/group/'+name+'/'+dir)

def set_pass_gr(name=''):
	if name!="":
		try:L=open_Groups()
		except:L=Ldf
		Lg=[]
		for i in L:
			if i[0]==name and len(i)==2: 
					pas=inputbox()
					i=[i[0],i[1], pas]
			Lg.append(i)
			save_Groups(Lg)


def rem_pass_gr(name=''):
	if name!="":
		try:L=open_Groups()
		except:L=Ldf
		Lg=[]
		for i in L:
			if i[0]==name and len(i)==3: 
				pas=inputbox()
				if pas==i[2]: i=[i[0],i[1]]
				else: showMessage('Отклонено!', 'Неверный пароль')
			Lg.append(i)
			save_Groups(Lg)

def get_access_gr(name=''):
	if name!="":
		true_name=name.replace('[COLOR 44FFFFFF]','').replace('[/COLOR]','')
		try:L=open_Groups()
		except:L=Ldf
		for i in L:
			if i[0]==true_name and len(i)==3:
				pas=inputbox()
				if pas==i[2]: return true_name
				else: showMessage('Отклонено!', 'Неверный пароль')
		return name

def rename_gr(name=''):
	ng=inputbox()
	if name!="" and ng!='':
		SEND('/group/'+name+'/rename/'+ng)

def extend_gr(name=''):
	if name!="":
		try:L=open_Groups()
		except:L=Ldf
		Lg=[]
		gi=None
		for i in L:
			if i[0]==name: gi=i[1]
			else: Lg.append(i[0])
		
		sel = xbmcgui.Dialog()
		r = sel.select("Объединить с группой:", Lg)
		if r>=0:
			r_nm=Lg[r]
			gr=[]
			for i in L:
				if i[0]==r_nm:
					if len(i)==3: 
						if i[2]!='false':
							showMessage('Недоступно', 'Группа заблокирована')
							return ""
					gr=i[1]
			SEND('/group/'+name+'/unite/'+gr)



def archive(name):#, sd='0'
	try:sd=__settings__.getSetting("Sel_sday")
	except: sd='0'
	if sd=="":sd='0'
	La=get_all_archive()
	ssec=int(sd)*24*60*60
	t=time.localtime(time.time() - ssec)
	add_item ('[COLOR FF10FF10][B]'+time.strftime('%d.%m.%Y',t)+" - "+unmark(name)+"[/B][/COLOR]", "select_date", 'url', '0' )
	da={}
	Lm=[]
	for n2id in La:
		serv_id=n2id['srv_id']
		#try: 
		exec ("import "+serv_id+"; arh="+serv_id+".ARH()")
		#n2id=arh.name2id()
		try:aid=n2id[lower(unmark(name))]
		except: aid=""
		#from aid3 import *
		#n2id
		if aid!="":
			L=arh.Archive(aid, t)
			for i in L:
				#url=i['url']
				#title=i['title']
				st=i['time']
				#add_item (st+" - "+title, "play2", [url,], 'archive' )
				try: 
					i2=da[st]
					urls=i2['url']
					url=i['url']
					urls.append(url)
					i2['url']=urls
					da[st]=i2
				except: 
					url=i['url']
					i['url']=[url,]
					da[st]=i
	for d in da.keys():
			urls=da[d]['url']
			title=da[d]['title']
			st=da[d]['time']
			add_item (st+" - "+title, "play2", urls, 'archive' )
			
	#xbmcplugin.addSortMethod(handle, xbmcplugin.SORT_METHOD_LABEL)
	#xbmcplugin.endOfDirectory(handle)


def select_date():
		L=[]
		for i in range (0,10):
			ssec=i*24*60*60
			t=time.localtime(time.time() - ssec)
			st=time.strftime('%d.%m.%Y',t)
			L.append(st)
		sel = xbmcgui.Dialog()
		r = sel.select("Дата:", L)
		__settings__.setSetting("Sel_sday",str(r))
		xbmc.executebuiltin("Container.Refresh")

def get_arhive_date():
	try:sd=__settings__.getSetting("Sel_sday")
	except: sd='0'
	if sd=="":sd='0'
	ssec=int(sd)*24*60*60
	t=time.localtime(time.time() - ssec)
	return time.strftime('%d.%m.%Y',t)

def set_arhive_date(r):
	__settings__.setSetting("Sel_sday",str(r))

# ----------------------------------- данные ----------------------------------------------------


def ASE_start():
	srv=__settings__.getSetting("p2p_serv")
	prt=__settings__.getSetting("p2p_port")
	lnk='http://'+srv+':'+prt+'/webui/api/service?method=get_version&format=jsonp&callback=mycallback'#getstream?id='+CID
	pDialog = xbmcgui.DialogProgressBG()
	resp=getURL(lnk)
	if resp != '':
		return False
	else:
		#showMessage('Пазл ТВ', 'Запуск Ace Stream')
		pDialog.create('Пазл ТВ', 'Запуск Ace Stream ...')
		pDialog.update(0, message='Запуск Ace Stream ...')
		start_linux()
		start_windows()
		for i in range (0,10):
			pDialog.update(i*10, message='Запуск Ace Stream ...')
			xbmc.sleep(1500)
			resp=getURL(lnk)
			if resp != '':
				pDialog.close()
				return True
		pDialog.close()
		return False

def start_linux():
        import subprocess
        try:
            subprocess.Popen(['acestreamengine', '--client-console'])
        except:
            try:
                subprocess.Popen('acestreamengine-client-console')
            except: 
                try:
                    xbmc.executebuiltin('XBMC.StartAndroidActivity("org.acestream.media")')
                    xbmc.sleep(2000)
                    xbmc.executebuiltin('XBMC.StartAndroidActivity("org.xbmc.kodi")')
                except:
                    return False
        return True
    
def start_windows():
        try:
            import _winreg
            try:
                t = _winreg.OpenKey(_winreg.HKEY_CURRENT_USER, r'Software\AceStream')
            except:
                t = _winreg.OpenKey(_winreg.HKEY_CURRENT_USER, r'Software\TorrentStream')
            path = _winreg.QueryValueEx(t, r'EnginePath')[0]
            os.startfile(path)
            return True
        except:
            return False

def get_epg_directory():
	nm2id={}
	nml=[]
	for a in DBC.items():
		id=a[0]
		names=a[1]['names']
		for nm in names:
			nm2id[nm]=id
			nml.append(nm)
	
	response = eval(xbmc.executeJSONRPC('{"jsonrpc": "2.0", "method": "Files.GetDirectory", "params": {"directory": "plugin://plugin.program.pazl.epg/?mode=get"},"id": 1}'))
	print 'get_epg_directory'#response
	files=response["result"]["files"]
	D={}
	for i in files:
		id=i["label"]
		D[id]=eval(i["file"].replace('plugin://plugin.program.pazl.epg/?data=',''))
	return D
	

def get_arhive_list():
	L=eval(SEND('archive/list'))
	LL=[]
	for i in L:
		LL.append(i["cid"])
	return LL

def get_arhive_canale(cid):
	try:    sd=__settings__.getSetting("Sel_sday")
	except: sd='0'
	if sd=="":sd='0'
	D=eval(SEND('archive/cid/'+cid+'/day/'+str(sd)))
	L=[]
	for i in D.values():
		title =i["time"]+' - '+i["title"]
		id    =i["id"]
		L.append({'00':i["s_time"], 'title':title, 'id':id})
	L.sort()
	return L

def get_arhive_strm(id):
	print id
	serv_adr=__settings__.getSetting("serv_adr")
	url='http://'+serv_adr+'/archive/record/'+id.replace('|','%7C')
	L=eval(SEND('archive/records/'+id))
	return L

def get_arhive_streams(id):
	print id
	serv_adr=__settings__.getSetting("serv_adr")
	url='http://'+serv_adr+'/archive/record/'+id.replace('|','%7C')
	print url
	return url

def get_picons(title):
	print '== select_icon =='
	if " TV" not in title: title=title+" TV"
	title=title.replace(' HD', '').replace('(+1)', '').replace('(+2)', '').replace('(+3)', '').replace('(+4)', '').replace('(+5)', '').replace('(+6)', '')
	url='http://yandex.ru/images/search?text='+urllib.quote_plus(title)+'&isize=small&iorient=square'#&type=clipart
	print url
	hp=getURL3(url)
	ss='&quot;img_href&quot;:&quot;'
	L=mfindal(hp, ss, '&quot;')
	L2=[]
	for i in L:
		print i
		if 'http' in i: L2.append(i.replace(ss,''))
	return L2

def get_params():
	param=[]
	paramstring=sys.argv[2]
	if len(paramstring)>=2:
		params=sys.argv[2]
		cleanedparams=params.replace('?','')
		if (params[len(params)-1]=='/'):
			params=params[0:len(params)-2]
		pairsofparams=cleanedparams.split('&')
		param={}
		for i in range(len(pairsofparams)):
			splitparams={}
			splitparams=pairsofparams[i].split('=')
			if (len(splitparams))==2:
				param[splitparams[0]]=splitparams[1]
	return param


if __settings__.getSetting("xplay")=='true': 
	Player=pPlayer()
else:
	Player=xbmc.Player()

#Player=pPlayer()
Player2=p2Player()

